# wxFilterClassFactory Class Reference
[Streams]

`#include <wx/stream.h>`

Inheritance diagram for wxFilterClassFactory:
[legend]

## Detailed Description

Allows the creation of filter streams to handle compression formats such as gzip and bzip2.

For example, given a filename you can search for a factory that will handle it and create a stream to decompress it:

            factory = wxFilterClassFactory::Find(filename, wxSTREAM_FILEEXT);
            if (factory)
                stream = factory->NewStream(new wxFFileInputStream(filename));

wxFilterClassFactory::Find can also search for a factory by MIME type, HTTP encoding or by wxFileSystem protocol. The available factories can be enumerated using wxFilterClassFactory::GetFirst() and wxFilterClassFactory::GetNext().

##

Library: wxBase

Category: Streams

See also:
  wxFilterInputStream, wxFilterOutputStream, wxArchiveClassFactory, Archive Formats

const wxFilterClassFactory * | GetNext () const
| GetFirst and GetNext can be used to enumerate the available factories.
static const wxFilterClassFactory * | GetFirst ()
| GetFirst and GetNext can be used to enumerate the available factories.
## Public Member Functions
bool | CanHandle (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL) const
| Returns true if this factory can handle the given protocol, MIME type, HTTP encoding or file extension.
wxString | GetProtocol () const
| Returns the wxFileSystem protocol supported by this factory.
virtual const wxChar *const * | GetProtocols (wxStreamProtocolType type=wxSTREAM_PROTOCOL) const =0
| Returns the protocols, MIME types, HTTP encodings or file extensions supported by this factory, as an array of null terminated strings.
wxString | PopExtension (const wxString &location) const
| Remove the file extension of location if it is one of the file extensions handled by this factory.
void | PushFront ()
| Adds this class factory to the list returned by GetFirst()/GetNext().
void | Remove ()
| Removes this class factory from the list returned by GetFirst()/GetNext().
virtual wxFilterInputStream * | NewStream (wxInputStream &stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterOutputStream * | NewStream (wxOutputStream &stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterInputStream * | NewStream (wxInputStream *stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
virtual wxFilterOutputStream * | NewStream (wxOutputStream *stream) const =0
| Create a new input or output stream to decompress or compress a given stream.
## Static Public Member Functions
static const wxFilterClassFactory * | Find (const wxString &protocol, wxStreamProtocolType type=wxSTREAM_PROTOCOL)
| A static member that finds a factory that can handle a given protocol, MIME type, HTTP encoding or file extension.

List of all members.

## Member Function Documentation

bool wxFilterClassFactory::CanHandle | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` |
| ) |  |  | const

Returns true if this factory can handle the given protocol, MIME type, HTTP encoding or file extension.

When using `wxSTREAM_FILEEXT` for the second parameter, the first parameter can be a complete filename rather than just an extension.

static const wxFilterClassFactory* wxFilterClassFactory::Find | ( | const wxString & | protocol,
|  | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` |
| ) |  |  | `[static]`

A static member that finds a factory that can handle a given protocol, MIME type, HTTP encoding or file extension.

Returns a pointer to the class factory if found, or NULL otherwise. It does not give away ownership of the factory.

When using `wxSTREAM_FILEEXT` for the second parameter, the first parameter can be a complete filename rather than just an extension.

static const wxFilterClassFactory* wxFilterClassFactory::GetFirst | ( |  | ) | `[static]`

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

            wxString list;
            const wxFilterClassFactory *factory = wxFilterClassFactory::GetFirst();

            while (factory) {
                list << factory->GetProtocol() << wxT("\n");
                factory = factory->GetNext();
            }

GetFirst()/GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

const wxFilterClassFactory* wxFilterClassFactory::GetNext | ( |  | ) | const

GetFirst and GetNext can be used to enumerate the available factories.

For example, to list them:

            wxString list;
            const wxFilterClassFactory *factory = wxFilterClassFactory::GetFirst();

            while (factory) {
                list << factory->GetProtocol() << wxT("\n");
                factory = factory->GetNext();
            }

GetFirst()/GetNext() return a pointer to a factory or NULL if no more are available. They do not give away ownership of the factory.

wxString wxFilterClassFactory::GetProtocol | ( |  | ) | const

Returns the wxFileSystem protocol supported by this factory.

Equivalent to

     wxString(*GetProtocols())

.

virtual const wxChar* const* wxFilterClassFactory::GetProtocols | ( | wxStreamProtocolType | type = `wxSTREAM_PROTOCOL` | ) | const`[pure virtual]`

Returns the protocols, MIME types, HTTP encodings or file extensions supported by this factory, as an array of null terminated strings.

It does not give away ownership of the array or strings.

For example, to list the file extensions a factory supports:

            wxString list;
            const wxChar *const *p;

            for (p = factory->GetProtocols(wxSTREAM_FILEEXT); *p; p++)
                list << *p << wxT("\n");

virtual wxFilterOutputStream* wxFilterClassFactory::NewStream | ( | wxOutputStream * | stream | ) | const`[pure virtual]`

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

virtual wxFilterInputStream* wxFilterClassFactory::NewStream | ( | wxInputStream * | stream | ) | const`[pure virtual]`

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

virtual wxFilterOutputStream* wxFilterClassFactory::NewStream | ( | wxOutputStream & | stream | ) | const`[pure virtual]`

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

virtual wxFilterInputStream* wxFilterClassFactory::NewStream | ( | wxInputStream & | stream | ) | const`[pure virtual]`

Create a new input or output stream to decompress or compress a given stream.

If the parent stream is passed as a pointer then the new filter stream takes ownership of it. If it is passed by reference then it does not.

wxString wxFilterClassFactory::PopExtension | ( | const wxString & | location | ) | const

Remove the file extension of location if it is one of the file extensions handled by this factory.

void wxFilterClassFactory::PushFront | ( |  | ) |

Adds this class factory to the list returned by GetFirst()/GetNext().

It is not necessary to do this to use the filter streams. It is usually used when implementing streams, typically the implementation will add a static instance of its factory class.

It can also be used to change the order of a factory already in the list, bringing it to the front. This isn't a thread safe operation so can't be done when other threads are running that will be using the list.

The list does not take ownership of the factory.

void wxFilterClassFactory::Remove | ( |  | ) |

Removes this class factory from the list returned by GetFirst()/GetNext().

Removing from the list isn't a thread safe operation so can't be done when other threads are running that will be using the list.

The list does not own the factories, so removing a factory does not delete it.

|  | [ top ]